#include"function_define.h"
void hcl_yaw_bearing(int I_pd){
	ofstream ofile;
	ofile.open("./out_file/Post-processing-hcl_yaw_bearing.txt");
	F_yawbearing.resize(Num_cal, 8);
	Overhang = 0.0;
	VectorXd fai_T(Num_T);
	for (int i = 0; i < Num_T; i++){
		fai_T(i) = 1;
	}
	MatrixXd F_top_x(1, Num_cal), F_top_y(1, Num_cal);
	if (I_pd == 0){
		F_top_x.setZero();
		F_top_y.setZero();
	}
	else{
		F_top_x = M_top*fai_T.transpose()*A3_T*ddf_t.transpose();
		F_top_y = M_top*fai_T.transpose()*A3_T*ddf_t_pmn.transpose();
	}
	for (int i = 0; i < Num_cal; i++){
		F_yawbearing(i, 0) = F_FixedHub(i, 0) - F_top_x(0, i);//Fx
		F_yawbearing(i, 1) = F_FixedHub(i, 1) - F_top_y(0, i);//Fy
		F_yawbearing(i, 2) = F_FixedHub(i, 2) - M_top*9.8;//Fz
		F_yawbearing(i, 3) = sqrt(pow(F_yawbearing(i, 0), 2) + pow(F_yawbearing(i, 1), 2));//Fxy

		F_yawbearing(i, 4) = F_FixedHub(i, 4);//Mx
		F_yawbearing(i, 5) = F_FixedHub(i, 5) + F_FixedHub(i, 2)*Overhang;//My
		F_yawbearing(i, 6) = F_FixedHub(i, 6) - F_FixedHub(i, 1)*Overhang;//Mz
		F_yawbearing(i, 7) = sqrt(pow(F_yawbearing(i, 4), 2) + pow(F_yawbearing(i, 5), 2));//Fxy
	}

	ofile << " Fx \t Fy  \t Fz \t Fxy \t Mx \t My \t  Mz \t Mxy" << endl;
	for (int i = 0; i < Num_cal; i++){
		for (int j = 0; j < 8; j++){
			ofile << F_yawbearing(i, j) << "\t";
		}
		ofile << endl;
	}
	ofile.close();
	cout << "hcl_yawbearing end!" << endl;

}