#include"function_define.h"
void tower(int I_pd){
	ofstream ofile;
	if (I_pd == 0) ofile.open("./out_file/Modal analysis of tower_pmw.txt");
	else
	{
		ofile.open("./out_file/Modal analysis of tower_pmn.txt");
	}
	//--------------ȼҶƬ-------------

	VectorXd r(N_Y), m_r_Y(N_Y);//

	for (int i = 0; i < N_Y; i++) {
		r(i) = pre_Y(i, 0);            //뾶
		m_r_Y(i) = pre_Y(i, 5);         //ֲܶ
	}
	double kk, bb, mass_blad = 0, mass_blad_2 = 0, mass_blad_3 = 0;// һ׾ ׾ 
	for (int k = 0; k < N_Y - 1; k++){
		kk = (m_r_Y(k + 1) - m_r_Y(k)) / (r(k + 1) - r(k));
		bb = m_r_Y(k) - kk*r(k);
		mass_blad = mass_blad + 0.5*kk*(pow((r(k + 1)), 2) - pow((r(k)), 2)) + bb*(r(k + 1) - r(k));
		mass_blad_2 = mass_blad_2 + 1.0 / 3.0*kk*(pow((r(k + 1)), 3) - pow((r(k)), 3)) + 0.5*bb*(pow(r(k + 1), 2) - pow(r(k), 2));
		mass_blad_3 = mass_blad_3 + 0.25*kk*(pow((r(k + 1)), 4) - pow((r(k)), 4)) + 1.0 / 3.0*bb*(pow(r(k + 1), 3) - pow(r(k), 3));
	}
	//cout << "Ҷ:" << mass_blad<<endl;
	//--------------ΪԴ-----------

	MatrixXd M(Num_T, Num_T), K(Num_T, Num_T);
	VectorXd highTower(N_T), I(N_T), m_r(N_T);//rΪ뾶,sΪ,Iն
	M_top = 0;
	//cout << ":" << endl;
	//cout << "Please enter the total mass of the engine room:" << endl;
	//cin >> M_top;
	M_top = SR[21];
	for (int i = 0; i < N_T; i++) {
		highTower(i) = pre_T(i, 0) - pre_T(0, 0);    //߶
		m_r(i) = pre_T(i, 2);         //ֲܶ
		I(i) = pre_T(i, 3);          //Iն
	}

	double HTower;
	HTower = highTower(N_T - 1) - highTower(0);

	MatrixXd xhs(N_T, Num_T);
	for (int i = 0; i <N_T; i++)
		for (int j = 0; j < Num_T; j++){
		xhs(i, j) = pow((highTower(i) / HTower), j + 2);
		}

	//--------ļ㣨޼---------------
	for (int i = 0; i < Num_T; i++)
		for (int j = 0; j < Num_T; j++){
		M(i, j) = 0;
		for (int k = 0; k < N_T - 1; k++){
			kk = (m_r(k + 1) - m_r(k)) / (highTower(k + 1) - highTower(k));
			bb = m_r(k) - kk*highTower(k);
			M(i, j) = M(i, j) + 1.0 / (pow(HTower, i + j + 4))*(kk*(pow(highTower(k + 1), i + j + 6) - pow(highTower(k), i + j + 6)) / (i + j + 6) + bb*(pow(highTower(k + 1), i + j + 5) - pow(highTower(k), i + j + 5)) / (i + j + 5));
		}
		}

	//----------Ӽ------------
	for (int i = 0; i < M.rows(); i++)
		for (int j = 0; j < M.rows(); j++) M(i, j) = M_top + M(i, j);
	//----------ҶƬ------------
	MatrixXd  I_1(1, Num_T), I_2(1, Num_T), JZ[4];
	for (int i = 0; i < Num_T; i++){
		I_1(i) = 1;
		I_2(i) = (i + 2)*1.0 / (pre_T(N_T - 1, 0) - pre_T(0, 0));
	}
	JZ[0] = I_1.transpose()*I_1;
	JZ[1] = I_1.transpose()*I_2;
	JZ[2] = I_2.transpose()*I_1;
	JZ[3] = I_2.transpose()*I_2;
	if (I_pd == 0) M = M + JZ[0] * mass_blad *3.0 + JZ[3] * mass_blad_3*1.5;
	
	else
	{
		M = M + JZ[0] * mass_blad *3.0;
	}
	
	//MassBlade=mass_blad *3.0;
	//--------նȾļ ն---------------
	for (int i = 0; i < Num_T; i++)
		for (int j = 0; j < Num_T; j++){
		K(i, j) = 0;
		for (int k = 0; k < N_T - 1; k++){
			kk = (I(k + 1) - I(k)) / (highTower(k + 1) - highTower(k));
			bb = I(k) - kk*highTower(k);
			K(i, j) = K(i, j) + (i + 1)*(j + 1)*(i + 2)*(j + 2) / (pow(HTower, i + j + 4))*(kk*(pow(highTower(k + 1), i + j + 2) - pow(highTower(k), i + j + 2)) / (i + j + 2) + bb*(pow(highTower(k + 1), i + j + 1) - pow(highTower(k), i + j + 1)) / (i + j + 1));
		}
		}
	//--------նȾļ㣨---------------
	for (int i = 0; i < Num_T; i++)
		for (int j = 0; j < Num_T; j++){
		for (int k = 0; k < N_T - 1; k++){
			kk = (m_r(k + 1) - m_r(k)) / (highTower(k + 1) - highTower(k));
			bb = m_r(k) - kk*highTower(k);
			K(i, j) = K(i, j) - 9.8*(i + 2)*(j + 2) / ((i + j + 3)*pow(HTower, i + j + 4))*(kk*(pow(highTower(k + 1), i + j + 5) - pow(highTower(k), i + j + 5)) / (i + j + 5) + bb*(pow(highTower(k + 1), i + j + 4) - pow(highTower(k), i + j + 4)) / (i + j + 4));
		}
		}
	//--------նȾļ㣨---------------
	MatrixXd K_prime(Num_T, Num_T);
	for (int i = 0; i < Num_T; i++)
		for (int j = 0; j < Num_T; j++){
		K_prime(i, j) = (i + 2)*(j + 2) / ((i + j + 3)*HTower);
		K(i, j) = K(i, j) - K_prime(i, j)*(M_top + mass_blad*3.0)*9.8;
		}
	
	//--------նȾļ㣨P-detaЧӦ---------------
	MatrixXd K_p_deta(Num_T, Num_T);
	for (int i = 0; i < Num_T; i++){
	for (int j = 0; j < Num_T; j++){
	K_p_deta(i, j) = 0;
	for (int k = 0; k < N_T - 1; k++){
	kk = (m_r(k + 1) - m_r(k)) / (highTower(k + 1) - highTower(k));
	bb = m_r(k) - kk*highTower(k);
	K_p_deta(i, j) = K_p_deta(i, j) + (j + 2)*2.0 / (pow(HTower, i + j + 4))*(kk*(pow(highTower(k + 1), i + j + 5) - pow(highTower(k), i + j + 5)) / (i + j + 5) + bb*(pow(highTower(k + 1), i + j + 4) - pow(highTower(k), i + j + 4)) / (i + j + 4));
	}
	}
	}

	MatrixXd K_p_deta_m(Num_T, Num_T);
	for (int i = 0; i < Num_T; i++){
	for (int j = 0; j < Num_T; j++){
	K_p_deta_m(i, j) = 2 * (M_top + mass_blad)*(j + 2) / (HTower);
	}
	}

	K = K - K_p_deta - K_p_deta_m;
	


	//-----------ļ-----------

	int i, j;
	//m_ban
	EigenSolver<MatrixXd> es(M);
	MatrixXd lamuda = es.pseudoEigenvalueMatrix();     //ֵ
	MatrixXd p = es.pseudoEigenvectors();        //д
	MatrixXd lamuda_ban(Num_T, Num_T), pp(Num_T, Num_T), M_ban(Num_T, Num_T), M_ban_ni(Num_T, Num_T), D(Num_T, Num_T);
	for (i = 0; i < Num_T; i++)
		for (j = 0; j < Num_T; j++)
			lamuda_ban(i, j) = sqrt(lamuda(i, j));
	M_ban = p*lamuda_ban*p.inverse();
	M_ban_ni = M_ban.inverse();
	D = M_ban_ni.transpose()*K*M_ban_ni;

	EigenSolver<MatrixXd> es_d(D);
	MatrixXd lamuda_D = es_d.pseudoEigenvalueMatrix();     //ֵ
	MatrixXd x_D = es_d.pseudoEigenvectors();        //д
	VectorXd f(Num_T);
	for (i = 0; i < Num_T; i++) f(i) = sqrt(lamuda_D(i, i)) / (2 * 3.141592653);
	VectorXd f_zj = f;
	f_zj = bubble(f);
	ofile << "frequency" << endl << f_zj.transpose() << endl;

	MatrixXd A_T = M_ban_ni*x_D;
	ofile << "ģ̬" << endl << A_T << endl;
	int N1[3];//ȡǰģ̬
	for (int i = 0; i < Num_T; i++) {
		if (f_zj(0) == f(i)) N1[0] = i;
		else if (f_zj(1) == f(i)) N1[1] = i;
		else if (f_zj(2) == f(i)) N1[2] = i;
	}
	A3_T.resize(Num_T, 3);
	for (int i = 0; i < Num_T; i++){
		for (int j = 0; j < 3; j++){
			A3_T(i, j) = A_T(i, N1[j]);
		}
	}
	//--------ǰ׹͹նȾ--------
	M_T = A3_T.transpose()*M*A3_T;
	K_T = A3_T.transpose()*K*A3_T;

	double Alfa, Beta;
	VectorXd jpl = 2 * 3.141592653*f_zj;
	Alfa = 2 * (jpl(0)*jpl(1))*0.02 / (jpl(0) + jpl(1));
	Beta = 2 * damping_ratio_t / (jpl(0) + jpl(1));
	C_T = Alfa*M_T + Beta*K_T;

	ofile << "նȾ:" << endl << K_T << endl;
	ofile << ":" << endl << M_T << endl;
	ofile << ":" << endl << C_T << endl;

	ofile.close();
	cout << "Modal analysis of tower END!" << endl;
	cout << endl;
}
