#include"function_define.h"
MatrixXd get_mass_new(double fai);
void new_decoupling(){
	VectorXd A1_T(Num_T), A1_Y[3], A1_Y_pmn[3];
	for (int i = 0; i < Num_T; i++){
		A1_T(i) = A3_T(i, 0);
	}
	for (int II = 0; II < 3; II++){
		A1_Y[II].resize(Num_Y);
		A1_Y_pmn[II].resize(Num_Y);
		for (int i = 0; i < Num_Y; i++){
			A1_Y[II](i) = A3_Y[II](i, 0);
			A1_Y_pmn[II](i) = A3_Y_pmn[II](i, 0);
		}
	}
	MatrixXd Fy[3], Fy_pmn[3];
	//= A1_Y.transpose()*load_y;
	for (int i = 0; i < 3; i++){
		Fy[i].resize(1, Num_cal);
		Fy_pmn[i].resize(1, Num_cal);
		Fy[i] = A1_Y[i].transpose()*load_y[i];
		Fy_pmn[i] = A1_Y_pmn[i].transpose()*load_y_pmn[i];
	}
	MatrixXd Ft = A1_T.transpose()*load_t;
	MatrixXd Ft_pmn = A1_T.transpose()*load_t_pmn;

	MatrixXd K(8, 8), C(8, 8);
	K.setZero();
	C.setZero();
	for (int i = 0; i < 3; i++){
		K(i, i) = K_Y(0, 0);
		K(i + 3, i + 3) = K_Y_pmn(0, 0);
		C(i, i) = C_Y(0, 0);
		C(i + 3, i + 3) = C_Y_pmn(0, 0);
	}
	K(6, 6) = K_T(0, 0);
	C(6, 6) = C_T(0, 0);

	K(7, 7) = K_T(0, 0);
	C(7, 7) = C_T(0, 0);

	MatrixXd M = get_mass_new(0);

	ofstream ofile;
	ofile.open("./out_file/ansys_decoupling.txt");
	double gama = 0.5, bita = 0.25*pow((0.5 + gama), 2);
	double a0 = 1.0 / (bita*h*h), a1 = gama / (bita*h), a2 = 1.0 / (bita*h);
	double a3 = 1.0 / (bita * 2) - 1, a4 = gama / (bita)-1, a5 = h / 2.0*(gama / bita - 2);
	double a6 = h*(1 - gama), a7 = gama*h;
	MatrixXd Hz(8, Num_cal);
	for (int i = 0; i < Num_cal; i++){
		Hz(0, i) = Fy[0](0, i);
		Hz(1, i) = Fy[1](0, i);
		Hz(2, i) = Fy[2](0, i);

		Hz(3, i) = Fy_pmn[0](0, i);
		Hz(4, i) = Fy_pmn[1](0, i);
		Hz(5, i) = Fy_pmn[2](0, i);

		Hz(6, i) = Ft(0, i);
		Hz(7, i) = Ft_pmn(0, i);
	}
	VectorXd f_e(8), df_e(8), ddf_e(8), Q(8), Q_dt(8);
	for (int i = 0; i < 8; i++){
		f_e(i) = 0; df_e(i) = 0; ddf_e(i) = 0;
	}
	VectorXd f_e_dt(8), df_e_dt(8), ddf_e_dt(8);
	VectorXd F1(8);//Ч
	MatrixXd K_D(8, 8);
	MatrixXd ft(Num_cal, 8), dft(Num_cal, 8), ddft(Num_cal, 8);
	cout << "here" << endl;
	for (int j = 0; j < 8; j++) Q(j) = Hz(j, 0);
	ddf_e = M.inverse()*(Q - K *f_e - C *df_e);
	for (int j = 0; j < 8; j++) {
		ft(0, j) = f_e(j);
		dft(0, j) = df_e(j);
		ddft(0, j) = ddf_e(j);
	}
	for (int i = 1; i < Num_cal; i++){
		//M = get_mass(omiga*h*i);
		M = get_mass_new(fai_time(i));
		ofile << "i=" << i << endl;
		K_D = K + a0*M + a1*C;//Чն
		ofile << "i=" << i << endl;
		for (int j = 0; j < 8; j++) Q_dt(j) = Hz(j, i);//t+dtʱ̵ĺ
		F1 = Q_dt + M *(a0*f_e + a2*df_e + a3*ddf_e) + C *(a1*f_e + a4*df_e + a5*ddf_e);//Ч
		f_e_dt = K_D.inverse()*F1;
		ddf_e_dt = a0*(f_e_dt - f_e) - a2*df_e - a3*ddf_e;
		df_e_dt = df_e + a6*ddf_e + a7*ddf_e_dt;
		f_e = f_e_dt;
		df_e = df_e_dt;
		ddf_e = ddf_e_dt;
		ofile << "i=" << i << endl;
		for (int j = 0; j < 8; j++) {
			ft(i, j) = f_e(j);
			dft(i, j) = df_e(j);
			ddft(i, j) = ddf_e(j);
		}
		ofile << "i=" << i << endl;

		for (int II = 0; II < 3; II++){
			f_y[II](i, 0) = ft(i, II);
			df_y[II](i, 0) = dft(i, II);
			ddf_y[II](i, 0) = ddft(i, II);

			f_y_pmn[II](i, 0) = ft(i, II + 3);
			df_y_pmn[II](i, 0) = dft(i, II + 3);
			ddf_y_pmn[II](i, 0) = ddft(i, II + 3);
		}
		ofile << "i=" << i << endl;

		f_t(i, 0) = ft(i, 6);
		df_t(i, 0) = dft(i, 6);
		ddf_t(i, 0) = ddft(i, 6);
		ofile << "i=" << i << endl;

		f_t_pmn(i, 0) = ft(i, 7);
		df_t_pmn(i, 0) = dft(i, 7);
		ddf_t_pmn(i, 0) = ddft(i, 7);
		ofile << "i=" << i << endl;

	}
	ofile << "һģ̬ϵ:" << endl << ft << endl;
	cout << "Completion of coupling analysis!" << endl;
}
MatrixXd get_mass_new(double fai){
	ofstream ofile;
	ofile.open("./out_file/Ansys_decoupling_mass.txt", ios::app);
	MatrixXd fai_T(1, Num_T), dfai_T(1, Num_T), A1_T(Num_T, 1);
	for (int i = 0; i < Num_T; i++){
		fai_T(0, i) = 1;
		dfai_T(0, i) = (i + 2) / (pre_T(N_T - 1, 0) - pre_T(0, 0));
		A1_T(i, 0) = A3_T(i, 0);
	}


	MatrixXd mf(1, Num_Y), mfr(1, Num_Y);
	mf.setZero();
	mfr.setZero();
	VectorXd r(N_Y), m_r(N_Y);
	double kk, bb;
	for (int i = 0; i < N_Y; i++) {
		r(i) = pre_Y(i, 0);            //뾶
		m_r(i) = pre_Y(i, 5);         //ֲܶ
	}
	double R = pre_Y(N_Y - 1, 0) - pre_Y(0, 0);
	for (int i = 0; i < Num_Y; i++){
		for (int k = 0; k < N_Y - 1; k++){
			kk = (m_r(k + 1) - m_r(k)) / (r(k + 1) - r(k));
			bb = m_r(k) - kk*r(k);
			mf(0, i) = mf(0, i) + 1.0 / (pow(R, i + 2))*(1.0 / (i + 4)*kk*(pow((r(k + 1)), i + 4) - pow((r(k)), i + 4)) + 1.0 / (i + 3)*bb*(pow(r(k + 1), i + 3) - pow(r(k), i + 3)));
			mfr(0, i) = mfr(0, i) + 1.0 / (pow(R, i + 2))*(1.0 / (i + 5)*kk*(pow((r(k + 1)), i + 5) - pow((r(k)), i + 5)) + 1.0 / (i + 4)*bb*(pow(r(k + 1), i + 4) - pow(r(k), i + 4)));
		}
	}

	MatrixXd  A1_Y[3], A1_Y_pmn[3];

	for (int II = 0; II < 3; II++){
		A1_Y[II].resize(Num_Y, 1);
		A1_Y_pmn[II].resize(Num_Y, 1);
		for (int i = 0; i < Num_Y; i++){
			A1_Y[II](i, 0) = A3_Y[II](i, 0);
			A1_Y_pmn[II](i, 0) = A3_Y_pmn[II](i, 0);
		}
	}

	Overhang = 0.0;
	MatrixXd m_yt[3], m_yt2[3], m_yt3[3];
	for (int i = 0; i < 3; i++){
		m_yt[i].resize(1, 1);//m17 m27 m37
		m_yt2[i].resize(1, 1);//m47 m57 m67
		m_yt3[i].resize(1, 1);//m48 m58 m68
		m_yt[i] = A1_T.transpose()*fai_T.transpose()*mf*A1_Y[i] + A1_T.transpose()*dfai_T.transpose()*cos(fai + i*2.0944)*mfr*A1_Y[i];
		m_yt2[i] = A1_T.transpose()*dfai_T.transpose()*Overhang*sin(fai + i*2.0944)*mf*A1_Y_pmn[i];
		m_yt3[i] = A1_T.transpose()*fai_T.transpose()*cos(fai + i*2.0944)*mf*A1_Y_pmn[i];
	}

	MatrixXd MassMatrix(8, 8);
	MassMatrix.setZero();
	for (int i = 0; i < 8; i++){
		MassMatrix(i, i) = 1.0;
	}
	for (int i = 0; i < 3; i++){

		MassMatrix(i, 6) = m_yt[i](0, 0);
		MassMatrix(6, i) = MassMatrix(i, 6);

		MassMatrix(i + 3, 6) = m_yt2[i](0, 0);
		MassMatrix(6, i + 3) = MassMatrix(i + 3, 6);

		MassMatrix(i + 3, 7) = m_yt3[i](0, 0);
		MassMatrix(7, i + 3) = MassMatrix(i + 3, 7);
	}
	ofile << "MassMatrix:" << endl << MassMatrix << endl;
	return MassMatrix;
}
