#include<iostream>
#include <math.h>
#include<fstream>
#include <Eigen/Dense>
#include"YYR_FFT.h"
#include"function_define.h"
using namespace Eigen;
using namespace YYR_FFT;
using namespace std;
double cldc(const MatrixXd& ld, double angle, int n);
double czavg(const MatrixXd& ld, double h_n);//ƽٲֵ,nŵĸ߶ȣ
void windfarm_velocity(){
	R = R + R_lg;

	ofstream ofile;
	ofile.open("./out_file/Windfarm_data_velocity_out.txt");

	int m;//ģٸ
	int N;//Ƶʲ
	double omegaup;//Ƶ
	double B, L;//ģ糡ˮƽBֱL
	double dt;//ʱ
	B = 2 * R;
	L = R + H;
	//cout << "ģٵƵʲ:" << endl;
	//cin >> m_ve >> N;
	m_ve = 81;
	N = pow(2, 4);
	m = m_ve;
	dt = 0.5, omegaup = 2 * 3.141592;
	//m = 100, N = pow(2, 4), dt = 0.5, omegaup = 2 * 3.141592, B = 50.0, L = 50.0; //
	int M = 2 * N;
	double domega = omegaup / N;//Ƶ
	VectorXd pointX(m), pointY(m), pointU(m), pointSigema(m);//ģ㴦ꡢꡢƽ١ٱ׼
	VectorXd t(M*m);//ʱ̺ʱ
	MatrixXd v(m, M*m);//*ʱ䲽(*2*Ƶʲ)
	v.setZero(m, M*m);
	for (int i = 0; i < M*m; i++)
	{
		t(i) = i*dt;
	}
	complex <double> *** D;
	D = new complex <double> **[m];
	for (int i0 = 0; i0 < m; i0++)
		D[i0] = new complex <double> *[m];
	for (int i0 = 0; i0 < m; i0++)
		for (int j0 = 0; j0 < m; j0++)
			D[i0][j0] = new complex <double>[N];
	for (int i = 0; i < N; i++)//DԪ
	{
		for (int i1 = 0; i1 < m; i1++)
		{
			for (int i2 = 0; i2 < m; i2++)
			{
				D[i1][i2][i] = 0;

			}
		}
	}

	int a;
	int a0=1;
	//cout << "Please select input input parameters(Input corresponding numbers)" << endl;
	//cout << "1.Read the data file" << endl;
	//cout << "2.Manually enter data files" << endl;
	//cin >> a0;
	switch (a0)
	{
	case 1:a = 20;
		break;
	case 2:cout << "Please specify the number of data input per column" << endl;
		cin >> a;
	}
	VectorXd Hg(a);//ĸ߶
	VectorXd Ug(a);//㴦ƽ
	VectorXd sigemaUg(a);//㴦ٱ׼
	MatrixXd gdata(a, 3);//ݴgdataУֵʹ
	MatrixXd windfarm(a, 3);//һи߶ȣڶƽ٣ٱ׼
	if (a0 == 1)
	{

		ifstream in1("./input_file/Windfarm_data.txt");

		for (int i = 0; i < 20; i++)
			for (int j = 0; j < 3; j++) in1 >> windfarm(i, j);
		in1.close();
		for (int i = 0; i < 20; i++)
		{
			Hg(i) = windfarm(i, 0);
			Ug(i) = windfarm(i, 1);
			sigemaUg(i) = windfarm(i, 2);
		}


		for (int i = 0; i < 20; i++)
		{

			gdata(i, 0) = Hg(i);//һдĸ߶

		}
		for (int i = 0; i < 20; i++)
		{

			gdata(i, 1) = Ug(i);//ڶдƽ

		}
		for (int i = 0; i < 20; i++)
		{

			gdata(i, 2) = sigemaUg(i);//дٱ׼

		}
	}
	else if (a0 == 2)
	{

		cout << "Please enter the first column height data" << endl;
		for (int i = 0; i < a; i++)
		{
			cin >> Hg(i);
		}
		cout << "Please enter second columns of average wind speed data" << endl;
		for (int i = 0; i < a; i++)
		{
			cin >> Ug(i);
		}
		cout << "Please enter the third column standard deviation data" << endl;
		for (int i = 0; i < a; i++)
		{
			cin >> sigemaUg(i);
		}
	}
	else
	{
		cout << "Input error!" << endl;
	}
	//	std::cout << "gdata="<<gdata << endl;
	for (int i = 0; i < sqrt(m); i++)//m긳ֵ
	{
		for (int j2 = 0; j2<sqrt(m); j2++)
		{
			pointX(i*sqrt(m) + j2) = j2*B / (sqrt(m) - 1);
			pointY(i*sqrt(m) + j2) = 0.01 + i*L / (sqrt(m) - 1);
		}
	}

	for (int i = 0; i < m; i++)//ֵõÿӦ㴦
	{
		pointU(i) = cldc(gdata, pointY(i), 2);
		pointSigema(i) = cldc(gdata, pointY(i), 3);
	}
	
	int aa=5;//ûѡ
	double z0;//رֲڶȸ߶
	/*
	cout << "Please select the terrain type to determine the height of the surface roughness" << endl;
	cout << "1.City, forest" << endl;
	cout << "2.The suburbs, the numerous trees in the countryside" << endl;
	cout << "3.A village, a country with trees" << endl;
	cout << "4.There are few buildings in the open area and trees" << endl;
	cout << "5.plain" << endl;
	cout << "6.desert,sea" << endl;
	cin >> aa;
	*/
	switch (aa)
	{
	case 1:z0 = 0.7;
		break;
	case 2:z0 = 0.3;
		break;
	case 3:z0 = 0.1;
		break;
	case 4:z0 = 0.03;
		break;
	case 5:z0 = 0.01;
		break;
	case 6:z0 = 0.001;
		break;
	default:cout << "Input error" << endl;
	}
	double zi = 1000 * pow(z0, 0.18);
	VectorXd Lu(m);//ֳ߶
	for (int i = 0; i < m; i++)
	{
		if (pointY(i)>zi) Lu(i) = 280;
		else Lu(i) = 280 * pow((pointY(i) / zi), 0.35);
	}
	
	//double Lu = 300;
	MatrixXd Sw(m, N);

	for (int j = 0; j < m; j++)
	{
		MatrixXd thet(j + 1, N), thet1(j + 1, N), thet2(j + 1, N);
		thet = 3.141592*(thet1.setRandom(j + 1, N) + thet2.setOnes(j + 1, N));//λ

		for (int j1 = 0; j1 < m; j1++)
		{
			for (int l = 0; l < N; l++)
			{
				//Sw(j1, l) = 4 * pow(pointSigema(j1), 2)*Lu / pointU(j1) / pow((1 + 6 * (domega*(l + 1))*Lu / (2 * 3.141592*pointU(j1))), 5.0 / 3.0);
				Sw(j1, l) = 4 * pow(pointSigema(j1), 2)*Lu(j1) / pointU(j1) / pow((1 + 6 * (domega*(l + 1))*Lu(j1)/ (2 * 3.141592* pointU(j1))), 5.0 / 3.0);

			}
		}
		//std::cout << Sw << endl;
		//cout << "j=" << j << endl;
		//system("Pause");
		//ռϵʱϵγɹ׾
		int j1 = m, l = m, k = N;
		MatrixXd r(m, m);//֮ľ
		double phai;
		double *** Coh, *** tj;
		Coh = new  double **[j1];
		for (int i0 = 0; i0 < j1; i0++)
			Coh[i0] = new  double *[l];
		for (int i0 = 0; i0 < j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				Coh[i0][j0] = new  double[k];
		tj = new double **[j1];
		for (int i0 = 0; i0 < j1; i0++)
			tj[i0] = new  double *[l];
		for (int i0 = 0; i0 < j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				tj[i0][j0] = new  double[k];
		complex <double> *** S;
		S = new complex <double> **[j1];
		for (int i0 = 0; i0 < j1; i0++)
			S[i0] = new complex <double> *[l];
		for (int i0 = 0; i0 < j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				S[i0][j0] = new complex <double>[k];
		for (k = 0; k < N; k++)
		{
			for (j1 = 0; j1 < m; j1++)
			{
				for (l = 0; l < m; l++)
				{
					r(j1, l) = sqrt(256 * pow(pointX(j1) - pointX(l), 2) + 100 * pow(pointY(j1) - pointY(l), 2));
					//std::cout << "r(" << j1 << "," << l << ")=" << r(j1, l) ;
					Coh[j1][l][k] = exp(-(domega*(k + 1))*r(j1, l) / (2 * 3.141592*0.5*abs(pointU(j1) + pointU(l))));
					//std::cout << "Coh(" << j1 << "," << l << "," << k << ")=" << Coh[j1][l][k] ;
					tj[j1][l][k] = domega*(k + 1)*abs(pointY(j1) - pointY(l)) / (2 * 3.141592*0.5*abs(pointU(j1) + pointU(l)));
					//std::cout << "tj(" << j1 << "," << l << "," << k << ")=" << tj[j1][l][k] ;
					if (tj[j1][l][k] <= 0.1)
						phai = 10 * 3.1415912*tj[j1][l][k] / 4;
					else if (tj[j1][l][k] > 0.1 && tj[j1][l][k] <= 0.125)
						phai = -10 * 3.141592*tj[j1][l][k] + 1.25*3.141592;
					else
					{
						double a;
						a = (double)(rand() % 10001) / 10000;
						phai = (2 * a - 1)*3.141592;
					}

					//S[j1][l][k] = std::polar((sqrt(Sw(j1, k)*Sw(l, k))*Coh[j1][l][k]), phai);
					S[j1][l][k] = sqrt(Sw(j1, k)*Sw(l, k))*Coh[j1][l][k];
					//cout << "phai=" << phai << endl;
					//system("Pause");
					//std::cout << "S(" << j1 << "," << l << "," << k << ")=" << S[j1][l][k] ;

				}
			}
		}

		//cout << "j=" << j << endl;
		//system("Pause");

		//Ƿֽ⹦׾
		MatrixXcd s(m, m);
		complex <double> *** H;
		H = new complex <double> **[j1];
		for (int i0 = 0; i0 < j1; i0++)
			H[i0] = new complex <double> *[l];
		for (int i0 = 0; i0 < j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				H[i0][j0] = new complex <double>[k];
		for (int li = 0; li < N; li++)
		{
			for (int i = 0; i < m; i++)
			{
				for (int j2 = 0; j2 < m; j2++)
				{
					s(i, j2) = S[i][j2][li];
				}
			}
			LLT<MatrixXcd> lltOf(s);
			MatrixXcd h = lltOf.matrixL();

			for (int a1 = 0; a1 < m; a1++)
			{
				for (int b1 = 0; b1 < m; b1++)
				{
					H[a1][b1][li] = h(a1, b1);
					//std::cout << "H(" << a1 << "," << b1 << "," << li << ")=" << H[a1][b1][li] ;
				}
			}
		}
		//cout << "j=" << j << endl;
		//system("Pause");


		for (int a3 = 0; a3 < m; a3++)//DеjHеj
		{
			for (int b3 = 0; b3 < N; b3++)
			{
				D[a3][j][b3] = H[a3][j][b3];

			}
		}

		/*for (int i = 0; i < N; i++)
		{
		for (int i1 = 0; i1 < m; i1++)
		{
		for (int i2 = 0; i2 < m; i2++)
		{

		std::cout << "D(" << i1 << "," << i2 << "," << i << ")=" << D[i1][i2][i] ;
		}
		}
		}
		cout << "j=" << j << endl;
		system("Pause");*/
		MatrixXcd D1(m, N), B1(m, N);

		for (int i = 0; i < m; i++)
		{
			for (int j2 = 0; j2 < N; j2++)
			{
				D1(i, j2) = D[j][i][j2];//DеjиD1
			}
		}
		//cout << D1 << endl;
		//cout << "j=" << j << endl;
		//system("Pause");
		for (int a3 = 0; a3 < m; a3++)
		{
			for (int b3 = 0; b3 < N; b3++)
			{
				//				D[j][a3][b3] *= sqrt(2 * domega);
				B1(a3, b3) = D[j][a3][b3] * sqrt(2 * domega);
				//B1(a3, b3) = D1(a3, b3)* sqrt(2 * domega);//ӦB1=sqrt(2*domega).*D(j,:,:)
			}
		}
		//cout << B1 << endl;
		//cout << "j=" << j << endl;
		//system("Pause");
		MatrixXcd b2(j + 1, N), B2(j + 1, N);
		for (int ii = 0; ii < j + 1; ii++)
		{
			for (int jj = 0; jj < N; jj++)
			{
				b2(ii, jj) = B1(ii, jj);
			}
		}
		//cout << b2 << endl;
		//cout << "j=" << j << endl;
		//system("Pause");
		//thet << 5.9698, 1.4523, 3.8129, 3.0535, 5.6002, 4.7884, 2.8681, 0.1163, 5.1611, 2.7942, 3.8669, 4.9759, 5.7919, 4.6383, 1.1075, 2.5491;
		for (int ii1 = 0; ii1 < j + 1; ii1++)
		{
			for (int jj1 = 0; jj1 < N; jj1++)
			{
				B2(ii1, jj1) = b2(ii1, jj1)* polar(1.0, thet(ii1, jj1));//Ӧ:B2=B2*exp(i.*thet)
			}
		}
		//cout << B2 << endl;
		//system("Pause");
		MatrixXcd G(j + 1, M*m);
		for (int jj = 0; jj < j + 1; jj++)//ӦG(jj,1:M)=fft(B2(jj,:),M)
		{
			vector< complex<double> > B2jj;
			for (int i = 0; i < N; i++)
			{
				B2jj.push_back(complex<double>(B2(jj, i)));
			}
			for (int i = 0; i < N; i++)//B2N~MԪ0+0i
			{
				B2jj.push_back(complex<double>(0, 0));
			}
			FFT(B2jj.begin(), B2jj.end());

			for (int ii = 0; ii < M; ii++)
			{
				G(jj, ii) = B2jj[ii];
			}
			for (int jjj = 2; jjj <= m; jjj++)
			{
				for (int i = 0; i <M; i++)
				{
					G(jj, (jjj - 1)*M + i) = G(jj, i);
				}
			}
		}
		//cout << G << endl;
		//system("Pause");
		complex <double> vv, vv1;
		for (int p = 0; p < M*m; p++)
		{
			for (k = 0; k < j + 1; k++)
			{
				int p0 = p;
				vv1 = std::polar(1.0, ((k + 1)*1.0) / m*domega*p0*dt);
				vv = G(k, p)*vv1;
				//cout << vv1 << "  ";

				v(j, p) = v(j, p) + vv.real();
			}

		}
		for (int i0 = 0; i0<j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				delete[]Coh[i0][j0];
		for (int i0 = 0; i0 < j1; i0++)
			delete[]Coh[i0];
		delete[]Coh;
		for (int i0 = 0; i0<j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				delete[]tj[i0][j0];
		for (int i0 = 0; i0 < j1; i0++)
			delete[]tj[i0];
		delete[]tj;
		for (int i0 = 0; i0<j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				delete[]S[i0][j0];
		for (int i0 = 0; i0 < j1; i0++)
			delete[]S[i0];
		delete[]S;
		for (int i0 = 0; i0<j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				delete[]H[i0][j0];
		for (int i0 = 0; i0 < j1; i0++)
			delete[]H[i0];
		delete[]H;
		//cout << v << endl;
		//system("Pause");
		/*ofstream out1("E:/12251.txt");
		for (int i1 = 0; i1 < M*m; i1++)
		{

		out1 << v(0, i1) << endl;


		}*/
		//ͷŶ̬ڴ
		/*

		*/
	}//Ӧһfor


	//cout << v << endl;
	//cout << v;
	//system("Pause");
	VectorXd avg(m);
	for (int i = 0; i < m; i++)
	{
		double savg = 0;
		for (int ii = 0; ii < M*m; ii++)
		{
			savg = savg + v(i, ii);
		}
		avg(i) = savg / (M*m);
	}
	VectorXd sigema(m);
	for (int i = 0; i < m; i++)
	{
		double sum = 0;
		for (int ii = 0; ii < M*m; ii++)
		{
			sum = sum + pow((v(i, ii) - avg(i)), 2);
		}
		sigema(i) = sqrt(sum / (M*m));
	}
	//cout << "sigema" << endl<<sigema<<endl;
	//system("Pause");
	VectorXd lamuda(m);
	for (int i = 0; i < m; i++)
	{
		//lamuda(i) = sigema(i) / pointSigema(i);
		lamuda(i) = pointSigema(i) / sigema(i);
	}
	v.setZero(m, M*m);
	//cout << "lamuda" << endl << lamuda << endl;
	//system("Pause");


	for (int j = 0; j < m; j++)
	{
		MatrixXd thet(j + 1, N), thet1(j + 1, N), thet2(j + 1, N);
		thet = 3.141592*(thet1.setRandom(j + 1, N) + thet2.setOnes(j + 1, N));//λ

		for (int j1 = 0; j1 < m; j1++)
		{
			for (int l = 0; l < N; l++)
			{
				//Sw(j1, l) = 4 * pow(pointSigema(j1), 2)*Lu / pointU(j1) / pow((1 + 6 * (domega*(l + 1))*Lu / (2 * 3.141592*pointU(j1))), 5.0 / 3.0);
				Sw(j1, l) = lamuda(j1)*lamuda(j1) * 4 * pow(pointSigema(j1), 2)*Lu(j1) / pointU(j1) / pow((1 + 6 * (domega*(l + 1))*Lu(j1) / (2 * 3.141592* pointU(j1))), 5.0 / 3.0);

			}
		}
		//std::cout << Sw << endl;
		//cout << "j=" << j << endl;
		//system("Pause");
		//ռϵʱϵγɹ׾
		int j1 = m, l = m, k = N;
		MatrixXd r(m, m);//֮ľ
		double phai;
		double *** Coh, *** tj;
		Coh = new  double **[j1];
		for (int i0 = 0; i0 < j1; i0++)
			Coh[i0] = new  double *[l];
		for (int i0 = 0; i0 < j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				Coh[i0][j0] = new  double[k];
		tj = new double **[j1];
		for (int i0 = 0; i0 < j1; i0++)
			tj[i0] = new  double *[l];
		for (int i0 = 0; i0 < j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				tj[i0][j0] = new  double[k];

		/*double *** S;
		S = new  double **[j1];
		for (int i0 = 0; i0 < j1; i0++)
		S[i0] = new double *[l];
		for (int i0 = 0; i0 < j1; i0++)
		for (int j0 = 0; j0 < l; j0++)
		S[i0][j0] = new  double[k];*/
		complex <double> *** S;
		S = new complex <double> **[j1];
		for (int i0 = 0; i0 < j1; i0++)
			S[i0] = new complex <double> *[l];
		for (int i0 = 0; i0 < j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				S[i0][j0] = new complex <double>[k];
		for (k = 0; k < N; k++)
		{
			for (j1 = 0; j1 < m; j1++)
			{
				for (l = 0; l < m; l++)
				{
					r(j1, l) = sqrt(256 * pow(pointX(j1) - pointX(l), 2) + 100 * pow(pointY(j1) - pointY(l), 2));
					//std::cout << "r(" << j1 << "," << l << ")=" << r(j1, l) ;
					Coh[j1][l][k] = exp(-(domega*(k + 1))*r(j1, l) / (2 * 3.141592*0.5*abs(pointU(j1) + pointU(l))));
					//std::cout << "Coh(" << j1 << "," << l << "," << k << ")=" << Coh[j1][l][k] ;
					tj[j1][l][k] = domega*(k + 1)*abs(pointY(j1) - pointY(l)) / (2 * 3.141592*0.5*abs(pointU(j1) + pointU(l)));
					//					std::cout << "tj=" << tj << endl;
					if (tj[j1][l][k] <= 0.1)
						phai = 10 * 3.1415912*tj[j1][l][k] / 4;
					else if (tj[j1][l][k] > 0.1 && tj[j1][l][k] <= 0.125)
						phai = -10 * 3.141592*tj[j1][l][k] + 1.25*3.141592;
					else
					{
						double a;
						a = (double)(rand() % 10001) / 10000;
						phai = (2 * a - 1)*3.141592;
					}

					//S[j1][l][k] = std::polar((sqrt(Sw(j1, k)*Sw(l, k))*Coh[j1][l][k]), phai);
					S[j1][l][k] = sqrt(Sw(j1, k)*Sw(l, k))*Coh[j1][l][k];
					//std::cout << "S(" << j1 << "," << l << "," << k << ")=" << S[j1][l][k] ;

				}
			}
		}
		for (int i0 = 0; i0<j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				delete[]Coh[i0][j0];
		for (int i0 = 0; i0 < j1; i0++)
			delete[]Coh[i0];
		delete[]Coh;
		for (int i0 = 0; i0<j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				delete[]tj[i0][j0];
		for (int i0 = 0; i0 < j1; i0++)
			delete[]tj[i0];
		delete[]tj;
		//cout << "j=" << j << endl;
		//system("Pause");

		//Ƿֽ⹦׾
		MatrixXcd s(m, m);
		complex <double> *** H;
		H = new complex <double> **[j1];
		for (int i0 = 0; i0 < j1; i0++)
			H[i0] = new complex <double> *[l];
		for (int i0 = 0; i0 < j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				H[i0][j0] = new complex <double>[k];
		for (int li = 0; li < N; li++)
		{
			for (int i = 0; i < m; i++)
			{
				for (int j2 = 0; j2 < m; j2++)
				{
					s(i, j2) = S[i][j2][li];
				}
			}
			LLT<MatrixXcd> lltOf(s);
			MatrixXcd h = lltOf.matrixL();

			for (int a1 = 0; a1 < m; a1++)
			{
				for (int b1 = 0; b1 < m; b1++)
				{
					H[a1][b1][li] = h(a1, b1);
					//std::cout << "H(" << a1 << "," << b1 << "," << li << ")=" << H[a1][b1][li] ;
				}
			}
		}
		//cout << "j=" << j << endl;
		//system("Pause");
		for (int i0 = 0; i0<j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				delete[]S[i0][j0];
		for (int i0 = 0; i0 < j1; i0++)
			delete[]S[i0];
		delete[]S;

		for (int a3 = 0; a3 < m; a3++)//DеjHеj
		{
			for (int b3 = 0; b3 < N; b3++)
			{
				D[a3][j][b3] = H[a3][j][b3];

			}
		}
		for (int i0 = 0; i0<j1; i0++)
			for (int j0 = 0; j0 < l; j0++)
				delete[]H[i0][j0];
		for (int i0 = 0; i0 < j1; i0++)
			delete[]H[i0];
		delete[]H;
		/*for (int i = 0; i < N; i++)
		{
		for (int i1 = 0; i1 < m; i1++)
		{
		for (int i2 = 0; i2 < m; i2++)
		{

		std::cout << "D(" << i1 << "," << i2 << "," << i << ")=" << D[i1][i2][i] ;
		}
		}
		}
		cout << "j=" << j << endl;
		system("Pause");*/
		MatrixXcd D1(m, N), B1(m, N);

		for (int i = 0; i < m; i++)
		{
			for (int j2 = 0; j2 < N; j2++)
			{
				D1(i, j2) = D[j][i][j2];//DеjиD1
			}
		}
		//cout << D1 << endl;
		//cout << "j=" << j << endl;
		//system("Pause");
		for (int a3 = 0; a3 < m; a3++)
		{
			for (int b3 = 0; b3 < N; b3++)
			{
				//				D[j][a3][b3] *= sqrt(2 * domega);
				B1(a3, b3) = D[j][a3][b3] * sqrt(2 * domega);
				//B1(a3, b3) = D1(a3, b3)* sqrt(2 * domega);//ӦB1=sqrt(2*domega).*D(j,:,:)
			}
		}
		//cout << B1 << endl;
		//cout << "j=" << j << endl;
		//system("Pause");
		MatrixXcd b2(j + 1, N), B2(j + 1, N);
		for (int ii = 0; ii < j + 1; ii++)
		{
			for (int jj = 0; jj < N; jj++)
			{
				b2(ii, jj) = B1(ii, jj);
			}
		}
		//cout << b2 << endl;
		//cout << "j=" << j << endl;
		//system("Pause");
		//thet << 5.9698, 1.4523, 3.8129, 3.0535, 5.6002, 4.7884, 2.8681, 0.1163, 5.1611, 2.7942, 3.8669, 4.9759, 5.7919, 4.6383, 1.1075, 2.5491;
		for (int ii1 = 0; ii1 < j + 1; ii1++)
		{
			for (int jj1 = 0; jj1 < N; jj1++)
			{
				B2(ii1, jj1) = b2(ii1, jj1)* polar(1.0, thet(ii1, jj1));//Ӧ:B2=B2*exp(i.*thet)
			}
		}
		//cout << B2 << endl;
		//system("Pause");
		MatrixXcd G(j + 1, M*m);
		for (int jj = 0; jj < j + 1; jj++)//ӦG(jj,1:M)=fft(B2(jj,:),M)
		{
			vector< complex<double> > B2jj;
			for (int i = 0; i < N; i++)
			{
				B2jj.push_back(complex<double>(B2(jj, i)));
			}
			for (int i = 0; i < N; i++)//B2N~MԪ0+0i
			{
				B2jj.push_back(complex<double>(0, 0));
			}
			FFT(B2jj.begin(), B2jj.end());

			for (int ii = 0; ii < M; ii++)
			{
				G(jj, ii) = B2jj[ii];
			}
			for (int jjj = 2; jjj <= m; jjj++)
			{
				for (int i = 0; i <M; i++)
				{
					G(jj, (jjj - 1)*M + i) = G(jj, i);
				}
			}
		}
		//cout << G << endl;
		//system("Pause");
		complex <double> vv, vv1;
		for (int p = 0; p < M*m; p++)
		{
			for (k = 0; k < j + 1; k++)
			{
				int p0 = p;
				vv1 = std::polar(1.0, ((k + 1)*1.0) / m*domega*p0*dt);
				vv = G(k, p)*vv1;
				//cout << vv1 << "  ";

				v(j, p) = v(j, p) + vv.real();
			}

		}

		//cout << v << endl;
		//system("Pause");
		/*ofstream out1("E:/12251.txt");
		for (int i1 = 0; i1 < M*m; i1++)
		{

		out1 << v(0, i1) << endl;


		}*/
		//ͷŶ̬ڴ
		/*

		*/
	}//Ӧһfor


	ofstream out("vv.txt");
	for (int i = 0; i < m; i++)
	{
		for (int i1 = 0; i1 < M*m; i1++)
		{
			out << v(i, i1) << ' ';
		}
		out << endl;
	}
	
	//system("Pause");
	//--------ÿһƽ-------

	VectorXd velocity_avg(m_ve);
	int N_r, N_c;
	N_r = int(sqrt(m_ve)) - 1;
	N_c = N_r;
	double a1, b1;
	a1 = 2 * R / (double(N_r));
	b1 = (H + R) / (double(N_c));
	VectorXd X(m_ve), Y(m_ve);
	for (int i = 0; i < m_ve; i++){
	X(i) = i % (N_r + 1) * a1;
	Y(i) = int(i / (N_r + 1)) * b1;
	}        //ʼڵ

	for (int i = 0; i < m_ve; i++){
	velocity_avg(i) = czavg(windfarm, Y(i));
	}

	//---------------

	MatrixXd v1 = v.transpose();
	velocity.resize(v1.rows(), v1.cols() + 1);
	for (int i = 0; i < v1.rows(); i++){
	velocity(i, 0) = dt*i;
	for (int j = 1; j < v1.cols() + 1; j++){
	velocity(i, j) = v1(i, j - 1) + velocity_avg(j - 1);
	}
	}
	
	ofile << "ƽ:" << endl;
	for (int i = 0; i < m_ve; i++) ofile << velocity_avg(i) << "\t";
	ofile << endl;

	ofile << "ʱ:" << endl << endl;
	for (int i = 0; i < v1.rows(); i++){
		for (int j = 0; j < v1.cols(); j++) ofile << v1(i, j) << "\t";
		ofile << endl;
	}

	ofile << "ʱ:" << endl << endl;
	for (int i = 0; i < velocity.rows(); i++){
	for (int j = 0; j < velocity.cols(); j++) ofile << velocity(i, j) << "\t";
	ofile << endl;
	}

	ofile.close();
	//std::cout << "v=" << endl << v << endl;
	cout << "Wind field calculation finished!" << endl;
	R = R - R_lg;
}
//ֵ
double cldc(const MatrixXd& ld, double angle, int n) {
	int i, n2 = ld.rows();
	double jg1 = 0;
	for (i = 0; i<n2 - 1; i++){
		if (angle >= ld(i, 0) && angle<ld(i + 1, 0))
			jg1 = ld(i, n - 1) + (ld(i + 1, n - 1) - ld(i, n - 1)) / (ld(i + 1, 0) - ld(i, 0))*(angle - ld(i, 0));
	}
	return jg1;
}
double czavg(const MatrixXd& ld, double h_n){
	int i, n2 = ld.rows();
	double jg1 = 0;
	for (i = 0; i<n2 - 1; i++){
		if (h_n >= ld(i, 0) && h_n<ld(i + 1, 0))
			jg1 = ld(i, 1) + (ld(i + 1, 1) - ld(i, 1)) / (ld(i + 1, 0) - ld(i, 0))*(h_n - ld(i, 0));
	}
	return jg1;
}

